scriptvar string command;
scriptvar int theinteger1;

on speech<"[*">(object speaker, string arg)
{
  // Only listen to speech which we produce!
  if(speaker != this)
  {
    return(0x00);
  }

  // Split the argument into a string we can handle
  list args;
  split(args, arg);
  int argcount = numInList(args);

  // Check the argument count
  if(argcount < 1)
  {
    return(0x01);
  }

  int test = 0;
  int modify = 0;
  int query = 1;
  int needloc = 0;
  int needobj = 0;

  // Assume we have a valid command
  command = args[0];

  // Handle alternatives
  if(command == "tele")
  {
    command = "teleport";
  }

  // Verify the command
  if(command == "")
  {
  }
  else { if(command == "getserial")
  {
    needobj = 1;
  }
  else { if(command == "gethue")
  {
    needobj = 1;
  }
  else { if(command == "getheight")
  {
    needobj = 1;
  }
  else { if(command == "getelevation")
  {
    needloc = 1;
  }
  else { if(command == "where")
  {
    systemMessage(speaker, "location = " + getLocation(speaker));
  }
  else { if(command == "teleport")
  {
    location temploc;

    if(argcount < 3)
    {
      systemMessage(speaker, "Where do you want to teleport to?");
      needloc = 1;
      query = 0;
    }
    else { if(argcount == 3)
    {
      setX(temploc, strtoi(args[1]));
      setY(temploc, strtoi(args[2]));
      setZ(temploc, getElevation(temploc));
      if( isInMap(temploc) )
      {
        teleport(speaker, temploc);
        systemMessage(speaker, "teleport(" + temploc + ") = " + getLocation(speaker));
      }
      else
      {
        systemMessage(speaker, "location(" + temploc + ") = invalid!");
      }      
    }
    else { if(argcount == 4)
    {
      setX(temploc, strtoi(args[1]));
      setY(temploc, strtoi(args[2]));
      setZ(temploc, strtoi(args[3]));
      if( isInMap(temploc) )
      {
        teleport(speaker, temploc);
        systemMessage(speaker, "teleport(" + temploc + ") = " + getLocation(speaker));
      }
      else
      {
        systemMessage(speaker, "teleport(" + temploc + ") = invalid!");
      }      
    } } }
  }
  else { if(command == "sethue")
  {
    theinteger1 = strtoi(args[1]);
    needobj = 1;
    modify = 1;
  }
  else { if(command == "spawn")
  {
    systemMessage(speaker, "Where do you want the NPC to spawn?");
    theinteger1 = strtoi(args[1]);
    needloc = 1;
    modify = 1;
  }
  else { if(command == "test")
  {
    // Check the argument count
    if(argcount < 2)
    {
      systemMessage(speaker, "What do you want to test?");
      return(0x01);
    }

    // Assume we have a valid test command
    command = args[1];   
    test = 1;

    // Verify the test command
    if(command == "")
    { 
    }
    else { if(command == "canseeloc")
    { 
      needloc = 1;
    }
    else { if(command == "canseeobj")
    { 
      needobj = 1;
    }
    else
    {
      // Invalid test command, so abort the command
      command = "";
    } } }
  }
  else
  {
    // Invalid command, so abort the command
    command = "";
  } } } } } } } } } }
 
  if(command != "")
  {
    if(needloc != 0)
    {
      if(test != 0)
      { 
        systemMessage(speaker, "Click on the location you want to test.");
      }
      else { if(modify != 0)
      {
        systemMessage(speaker, "Click on the location you want to modify.");
      }
      else { if(query != 0)
      {
        systemMessage(speaker, "Click on the location you want to query.");
      } } }
      targetLoc(speaker, this);
    }
    if(needobj != 0)
    {
      if(test != 0)
      {
        systemMessage(speaker, "Click on the object you want to test.");
      }
      else { if(modify != 0)
      {
        systemMessage(speaker, "Click on the object you want to modify.");
      }
      else { if(query != 0)
      {
        systemMessage(speaker, "Click on the object you want to query.");
      } } }
      targetObj(speaker, this);
    }
  }

  return(0x01);
}

on targetloc(object user, location place, integer objtype)
{
  if(!isInMap(place))
  {
    return(0x00);
  }

  string tempstring = "";

  if(command == "canseeloc")
  {
    integer result = canSeeLoc(user, place);
    tempstring = tempstring + "CanSeeLoc (serial=" + objtoint(user) + ", location=" + place + ") = " + result;
  }
  if(command == "teleport")
  {
    teleport(user, place);
    systemMessage(user, "teleport(" + place + ") = " + getLocation(user));
  }
  if(command == "getelevation")
  {
    integer result = getElevation(place);
    tempstring = tempstring + "GetElevation (location=" + place + ") = " + result;

    systemMessage(user, tempstring);
    tempstring = "";

    result = getElevationAt(getX(place), getY(place));
    tempstring = tempstring + "GetElevationAt (location=" + place + ") = " + result;
  }
  if(command == "spawn")
  {
    object npc = createGlobalNPCAtSpecificLoc(theinteger1, place);
  }

  if(tempstring != "")
  {
    systemMessage(user, tempstring);
  }
  command = "";

  return(0x01);
}

on oortargetobj(object user, object usedon)
{
  if(usedon == NULL())
  {
    return(0x00);
  }

  string tempstring = "";

  if(command == "getheight")
  {
    integer result = getHeight(usedon);
    tempstring = tempstring + "GetHeight (serial=" + objtoint(usedon) + ") = " + result;
  }
  if(command == "gethue")
  {
    integer result = getHue(usedon);
    tempstring = tempstring + "GetHue (serial=" + objtoint(usedon) + ") = " + result;
  }
  if(command == "getserial")
  {
    integer result = objtoint(usedon);
    if(result >= 0)
    {
      tempstring = tempstring + "serial = " + result;
    } 
    else
    {
      tempstring = tempstring + "serial = " + result + " or " + objToStr(usedon);
    }
  }
  if(command == "canseeobj")
  {
    integer result = canSeeObj(user, usedon);
    tempstring = tempstring + "CanSeeObj (serial=" + objtoint(user) + ", serial=" + objtoint(usedon) + ") = " + result;
  }
  if(command == "sethue")
  {
    integer oldhue = getHue(usedon);
    setHue(usedon, theinteger1);
    tempstring = tempstring + "Hue was: " + oldhue + ", is now: " + getHue(usedon);
  }

  if(tempstring != "")
  {
    systemMessage(user, tempstring);
  }
  command = "";

  return(0x01);
}